#!/usr/bin/env python
# encoding: utf-8

from collections import OrderedDict																#从collections导入OrderedDict类
import sys																						#导入sys模块

_board_classes = {}																				#板子类型字典

class BoardMeta(type):																			#类BoardMeta，类的模板，所以必须从`type`类型派生
    def __init__(cls, name, bases, dct):														#类似构造函数，self类似this指针，其他是强制传入的参数
        super(BoardMeta, cls).__init__(name, bases, dct)										#super() 函数是用于调用父类(超类)的一个方法。

        if 'abstract' not in cls.__dict__:
            cls.abstract = False
        if cls.abstract:
            return

        board_name = getattr(cls, 'name', name)
        if board_name in _board_classes:
            raise Exception('board named %s already exists' % board_name)
        _board_classes[board_name] = cls

class Board:
    abstract = True																				#变量abstract

    def __init__(self):																			#初始化实例，self表示创建的实例本身
        pass

Board = BoardMeta('Board', Board.__bases__, dict(Board.__dict__))								#

class sitl(Board):
	pass

class linux(Board):
	pass
	
class pxfplus(linux):
    pass
	
def list_boards():					
    print(sorted(list(_board_classes.keys())))	

list_boards()